#include "stdafx.h"
#include "OmapOperation.h"

CString Utf8ToCString(const char* strUtf8)
{
	if (strUtf8 == NULL)
		return _T("");

	WORD *strBuf = OApiUtf8ToUtf16((char*)strUtf8, NULL, NULL);
	CString strInfo = (TCHAR*)strBuf;
	free(strBuf);

	return strInfo;
}

char* CStringToUtf8(CString &strTxt, char* strUtf8, int nBuf)
{
	OApiUtf16ToUtf8((WORD*)(LPCTSTR(strTxt)), (BYTE*)strUtf8, nBuf);
	return strUtf8;
}
OmapOperation::OmapOperation()
{
}

int OmapOperation::m_iApp = 0;
OmapOperation::~OmapOperation()
{

}
CString OmapOperation::GetLatlng(void* pData, int nData)
{
	CString ss;
	if (nData <= 0)
	{
		return ss;
	}
	tagOmapLatlng* pOll = (tagOmapLatlng*)pData;
	ss.Format(L"%lf,%lf", pOll->lat, pOll->lng);
	return ss;
}
CString OmapOperation::ShowPic(void* pData, int nData)
{
	CString ss;
	if (nData <= 0)
	{
		return ss;
	}
	tagOPhotoMapPic* pom = (tagOPhotoMapPic*)pData;
	int nPom = nData / sizeof(tagOPhotoMapPic);
	ss.Format(L"id=%lld,%d,%d,%lf,%lf", pom->idPic, nPom, pom->iAction, pom->lat, pom->lng);
	return ss;
}
CString OmapOperation::GetOmapObj(void* pData,int nData)
{
	int r = g_omapApi.FollowObjChange();
	CString strInfo;
	if (nData<=0)
	{
		return strInfo;
	}
	tagOApiObjectOptHdr* pOoh = (tagOApiObjectOptHdr*)pData;
	if (pOoh->iType == OMAP_OBJ_TYPE_GROUP)
	{
		tagOApiObjGroup* pGroup = GetOmapGroupFromBuf(pOoh + 1, nData - sizeof(tagOApiObjectOptHdr));
		strInfo.AppendFormat(_T("name = %s\r\n"), Utf8ToCString(pGroup->strName));
		strInfo.AppendFormat(_T("child = %d\r\n"), pGroup->nChild);
		FreeOmapObject(pGroup, OMAP_OBJ_TYPE_GROUP);
	}
	else if (pOoh->iType == OMAP_OBJ_TYPE_SIGN)
	{
		tagOApiMapSign* pSign = GetOmapSignFromBuf(pOoh + 1, nData - sizeof(tagOApiObjectOptHdr));
		strInfo.AppendFormat(_T("name = %s\r\n"), Utf8ToCString(pSign->strName));
		strInfo.AppendFormat(_T("latlng = %lf,%lf\r\n"), pSign->lat, pSign->lng);
		FreeOmapObject(pSign, OMAP_OBJ_TYPE_SIGN);
	}
	else if (pOoh->iType == OMAP_OBJ_TYPE_TRACK)
	{
		tagOApiMapTrack* pTrack = GetOmapTrackFromBuf(pOoh + 1, nData - sizeof(tagOApiObjectOptHdr));
		strInfo.AppendFormat(_T("name = %s\r\n"), Utf8ToCString(pTrack->strName));
		strInfo.AppendFormat(_T("TrackPointCount = %d\r\n"), pTrack->nMtp);
		FreeOmapObject(pTrack, OMAP_OBJ_TYPE_TRACK);
	}
	else if (pOoh->iType == OMAP_OBJ_TYPE_SHAPE)
	{
		tagOApiMapShape* pShape = GetOmapShapeFromBuf(pOoh + 1, nData - sizeof(tagOApiObjectOptHdr));
		strInfo.AppendFormat(_T("name = %s\r\n"), Utf8ToCString(pShape->strName));
		strInfo.AppendFormat(_T("VertexCount = %d\r\n"), pShape->nMtp);
		FreeOmapObject(pShape, OMAP_OBJ_TYPE_SHAPE);
	}
	else if (pOoh->iType == OMAP_OBJ_TYPE_DIR)
	{
		tagOApiMapDirections* pDir = GetOmapDirFromBuf(pOoh + 1, nData - sizeof(tagOApiObjectOptHdr));
		strInfo.AppendFormat(_T("name = %s\r\n"), Utf8ToCString(pDir->strName));
		strInfo.AppendFormat(_T("nUnit = %d\r\n"), pDir->nUnit);
		FreeOmapObject(pDir, OMAP_OBJ_TYPE_DIR);
	}
	else
	{
		strInfo = L"ֵ֧Ķ";
	}
	return strInfo;
}
CString OmapOperation::DecodeLatlng(void* pData, int nData)
{
	CString ss;
	if (nData <= 0)
	{
		return ss;
	}
	tagOmapGeoDecode* pgd = (tagOmapGeoDecode*)pData;
	ss.Format(L"γȣ%lf,%lf:\r\n", pgd->oll.lat, pgd->oll.lng);

	//ǷGEO_DECODE_ERR_WAITҪ1omapӷ
	if (pgd->nLevel == GEO_DECODE_ERR_WAIT)
		ss.AppendFormat(L"ȴ\r\n");
	else if (pgd->nLevel == GEO_DECODE_ERR_NO_DATA)
		ss.AppendFormat(L"ҲӦϢ\r\n");
	int i;
	for (i = 0; i < pgd->nLevel; i++)
	{
		ss.AppendFormat(L"%s\r\n", Utf8ToCString(pgd->strArea[i]));
	}
	return ss;
}
CString OmapOperation::TimeToLatlng(void* pData, int nData)
{
	CString ss;
	tagOPhotoMapPic* pOmp = (tagOPhotoMapPic*)pData;
	int nOmp = nData / sizeof(tagOPhotoMapPic);
	int nCount = 0;
	int i;
	for (i = 0; i < nOmp; i++)
	{
		if (pOmp[i].lat != 0 || pOmp[i].lng != 0)
		{
			nCount++;
		}
	}
	ss.Format(L"%dƬþγ:\r\n", nCount);

	for (i = 0; i < nOmp; i++)
	{
		if (pOmp[i].lat != 0 || pOmp[i].lng != 0)
		{
			ss.AppendFormat(L"%džγȣ%lf,%lf\r\n", i + 1, pOmp[i].lat, pOmp[i].lng);
		}
	}
	return ss;
}
tagOApiItemListV1*  OmapOperation::GetObjList(void* pData, int nData, int& nList)
{
	nList = 0;
	if (nData<=0)
	{
		return NULL;
	}
	nList = (nData - sizeof(tagOApiObjectOptHdr)) / sizeof(tagOApiItemListV1);
	tagOApiItemListV1* pOlv = (tagOApiItemListV1*)((BYTE*)pData + sizeof(tagOApiObjectOptHdr));
	return pOlv;
}
tagOApiObjectSrhRes*  OmapOperation::GetSrhObj(void* pData, int nData, int& nSrh)
{
	nSrh = 0;
	if (nData <= 0)
	{
		return NULL;
	}
	nSrh= (nData - sizeof(tagOApiObjectSrhReq)) / sizeof(tagOApiObjectSrhRes);
	tagOApiObjectSrhRes *pRes = (tagOApiObjectSrhRes *)((BYTE *)pData + sizeof(tagOApiObjectSrhReq));
	return pRes;
}
tagOmapGetMap* OmapOperation::GetMapData(void* pData, int nData)
{
	tagOApiObjectOptHdr* pOoh = (tagOApiObjectOptHdr*)pData;
	tagOmapGetMap *pGet = (tagOmapGetMap*)(pOoh + 1);
	//BYTE *pDataImg = (BYTE *)(pGet + 1);
	//int nDataIng = (nData - sizeof(tagOApiObjectOptHdr) - sizeof(tagOmapGetMap));
	return pGet;
}
void OmapOperation::ClickBtn()
{

}
void OmapOperation::SaveCfg()
{

}
int OmapOperation::SetBtn(void* pData, int nData)
{
	if (nData < sizeof(int))
		return -1;
	memcpy(&m_iApp, pData, sizeof(int));
	return m_iApp;
}
int OmapOperation::SetSysCoorPoint(void* pData, int nData)
{
	if (nData < sizeof(int))
		return -1;
	int iRet = 0;
	memcpy(&iRet, pData, sizeof(int));
	return iRet;
}
tagOApiSysCoorInfo *OmapOperation::GetSysCoorPoint(void* pData, int nData)
{
	if (nData == 0)
		return NULL;
	tagOApiSysCoorInfo *pOsc = (tagOApiSysCoorInfo*)pData;
	pOsc->strInfo = (char*)(pOsc + 1);
	return pOsc;
}
tagOApiObjChageHdr *OmapOperation::FollowObjChgList(void* pData, int nData)
{
	if (nData < sizeof(tagOApiObjChageHdr))
		return NULL;
	tagOApiObjChageHdr *pObjChange = (tagOApiObjChageHdr *)pData;
	pObjChange->pdwList = (DWORD *)(pObjChange + 1);
	return pObjChange;
}
tagOApiShapeFillCadPatHdr *OmapOperation::DeocdeShapeFillPatList(void* pData, int nData)
{
	tagOApiShapeFillCadPatHdr *pHdr = g_omapApi.DeocdeShapeFillPatList(pData, nData);
	return pHdr;
}