#pragma once
#include "OMapApi.h"


#ifdef OMAP_API_VERSION_V3
#define tagOApiMapSign tagOApiMapSignV3
#define tagOApiMapTrack tagOApiMapTrackV3
#define tagOApiMapShape tagOApiMapShapeV3
#define tagOApiMapDirections tagOApiMapDirectionsV3
#define tagOApiObjGroup tagOApiObjGroupV3

#define NewOmapGroup g_omapApi.NewOmapGroupV3
#define NewOmapSign g_omapApi.NewOmapSignV3
#define NewOmapTrack g_omapApi.NewOmapTrackV3
#define NewOmapShape g_omapApi.NewOmapShapeV3
#define NewOmapDir g_omapApi.NewOmapDirV3
#define NewOmapModel g_omapApi.NewOmapModelV3
#define FreeOmapObject g_omapApi.FreeOmapObjectV3
#define GetOmapGroupFromBuf g_omapApi.GetOmapGroupFromBufV3
#define GetOmapSignFromBuf g_omapApi.GetOmapSignFromBufV3
#define GetOmapTrackFromBuf g_omapApi.GetOmapTrackFromBufV3
#define GetOmapShapeFromBuf g_omapApi.GetOmapShapeFromBufV3
#define GetOmapDirFromBuf g_omapApi.GetOmapDirFromBufV3
#define SetOmapObject g_omapApi.SetOmapObjectV3

#define SetSysCoordProj g_omapApi.SetSysCoordProj
#define GetSysCoordProj g_omapApi.GetSysCoordProj
#define GetOmapWndRect g_omapApi.GetOmapWndRect
#define SetCusShowWnd g_omapApi.SetCusShowWnd
#define QueryCusShowWnd g_omapApi.QueryCusShowWnd
#define DelCusShowWnd g_omapApi.DelCusShowWnd
#define GetSysWebSocketConf g_omapApi.GetSysWebSocketConf
#define GetCusMapCfgList g_omapApi.GetCusMapCfgList
#define GetDeviceInfo g_omapApi.GetDeviceInfo
#define GetEnterpInfo g_omapApi.GetEnterpInfo
#define GetMapScreenBoxInfo g_omapApi.GetMapScreenBoxInfo
#define GetModelDataInfoList g_omapApi.GetModelDataInfoList
#else
#ifdef OMAP_API_VERSION_V2
OMAP_API_VERSION_V2
#define tagOApiMapSign tagOApiMapSignV2
#define tagOApiMapTrack tagOApiMapTrackV2
#define tagOApiMapShape tagOApiMapShapeV2
#define tagOApiMapDirections tagOApiMapDirectionsV2
#define tagOApiObjGroup tagOApiObjGroupV2

#define NewOmapGroup g_omapApi.NewOmapGroupV2
#define NewOmapSign g_omapApi.NewOmapSignV2
#define NewOmapTrack g_omapApi.NewOmapTrackV2
#define NewOmapShape g_omapApi.NewOmapShapeV2
#define NewOmapDir g_omapApi.NewOmapDirV2
#define NewOmapModel g_omapApi.NewOmapModelV3
#define FreeOmapObject g_omapApi.FreeOmapObjectV2
#define GetOmapGroupFromBuf g_omapApi.GetOmapGroupFromBufV2
#define GetOmapSignFromBuf g_omapApi.GetOmapSignFromBufV2
#define GetOmapTrackFromBuf g_omapApi.GetOmapTrackFromBufV2
#define GetOmapShapeFromBuf g_omapApi.GetOmapShapeFromBufV2
#define GetOmapDirFromBuf g_omapApi.GetOmapDirFromBufV2
#define SetOmapObject g_omapApi.SetOmapObjectV2

#define SetSysCoordProj g_omapApi.SetSysCoordProj
#define GetSysCoordProj g_omapApi.GetSysCoordProj
#define GetOmapWndRect g_omapApi.GetOmapWndRect
#define SetCusShowWnd g_omapApi.SetCusShowWnd
#define QueryCusShowWnd g_omapApi.QueryCusShowWnd
#define DelCusShowWnd g_omapApi.DelCusShowWnd
#define GetSysWebSocketConf g_omapApi.GetSysWebSocketConf
#define GetCusMapCfgList g_omapApi.GetCusMapCfgList
#define GetDeviceInfo g_omapApi.GetDeviceInfo
#define GetEnterpInfo g_omapApi.GetEnterpInfo
#define GetMapScreenBoxInfo g_omapApi.GetMapScreenBoxInfo
#define GetModelDataInfoList g_omapApi.GetModelDataInfoList
//...
#else
#define NewOmapGroup g_omapApi.NewOmapGroup
#define tagOApiMapSign tagOApiMapSignV1
#define tagOApiMapTrack tagOApiMapTrackV1
#define tagOApiMapShape tagOApiMapShapeV1
#define tagOApiMapDir tagOApiMapDirV1
#define tagOApiObjGroup tagOApiObjGroupV1

#define NewOmapGroup g_omapApi.NewOmapGroup
#define NewOmapSign g_omapApi.NewOmapSign
#define NewOmapTrack g_omapApi.NewOmapTrack
#define NewOmapShape g_omapApi.NewOmapShape
#define NewOmapDir g_omapApi.NewOmapDir
#define FreeOmapObject g_omapApi.FreeOmapObject
#define GetOmapGroupFromBuf g_omapApi.GetOmapGroupFromBuf
#define GetOmapSignFromBuf g_omapApi.GetOmapSignFromBuf
#define GetOmapTrackFromBuf g_omapApi.GetOmapTrackFromBuf
#define GetOmapShapeFromBuf g_omapApi.GetOmapShapeFromBuf
#define GetOmapDirFromBuf g_omapApi.GetOmapdirFromBuf
#define SetOmapObject g_omapApi.SetOmapObject
#endif
#endif
class OmapOperation
{
public:
	OmapOperation();
	static int m_iApp;
	static CString GetLatlng(void* pData, int nData);
	static CString ShowPic(void* pData, int nData);
	static CString GetOmapObj(void* pData, int nData);
	static CString DecodeLatlng(void* pData, int nData);
	static CString TimeToLatlng(void* pData,int nData);
	static tagOApiItemListV1*  GetObjList(void* pData, int nData, int& nList);
	static tagOApiObjectSrhRes*  GetSrhObj(void* pData, int nData, int& nSrh);
	static tagOmapGetMap* GetMapData(void* pData, int nData);
	static void ClickBtn();
	static void SaveCfg();
	static int SetBtn(void* pData, int nData);
	static int SetSysCoorPoint(void* pData, int nData);
	static tagOApiSysCoorInfo *GetSysCoorPoint(void* pData, int nData);
	static tagOApiObjChageHdr *FollowObjChgList(void* pData, int nData);
	static tagOApiShapeFillCadPatHdr *DeocdeShapeFillPatList(void* pData, int nData);
	~OmapOperation();
};

char* CStringToUtf8(CString &strTxt, char* strUtf8, int nBuf);
CString Utf8ToCString(const char* strUtf8);