#include "StdAfx.h"

#include "OSysDep.h"
#include "HybLib.h"

#include "OExif.h"
#include "Tdes_Md5.h"
/*
ԣ undefined anyֶֻ
SpatialFrequencyResponse
CFAPattern
OECF
MakerNote
DeviceSettingDescription  Щlibexifĵʾunwritable
*/
#define EXIF_TAG_OMAP_SIGN EXIF_TAG_NEW_CFA_PATTERN

void memsetOExifInfo(tagOExifInfo* ptag)
{
	if (ptag == NULL)
	{
		return;
	}
	if (ptag->pStrComent)
	{
		free(ptag->pStrComent);
	}
	memset(ptag, 0, sizeof(tagOExifInfo));
}


#define BUF_SIZE 100

//#ifndef OmFree
//#define OmFree(x) if (x!=NULL)\
//{\
//	free(x); \
//	x = NULL; \
//}
//#endif
//
//#ifndef zMalloc
//#define zMalloc(x) myMalloc(x)
//#endif

int OExofAnsiResive(char* strAnsi, int len)
{
	int size = (int)strlen(strAnsi);
	if (size < len)
		len = size;
	int i = len - 1;
	for (; i>-1; i--)
	{
		if (strAnsi[i] > 0)
			break;
	}
	if ((len - 1 - i) % 2 == 1)
	{
		strAnsi[len - 1] = 0;
		return len - 1;
	}
	else
	{
		strAnsi[len] = 0;
	}
	return len;
}
OExif::OExif()
{
	m_pExif = NULL;
	memset(&m_oei, 0, sizeof(tagOExifInfo));
}


OExif::~OExif()
{
	memsetOExifInfo(&m_oei);
	if (m_pExif)
	{
		exif_data_unref(m_pExif);
	}
}
ExifEntry* OExif::create_tag(ExifIfd ifd, ExifTag tag, size_t len)
{
	/* Create a memory allocator to manage this ExifEntry */
	ExifMem *mem = exif_mem_new_default();
	//ASSERT(mem != NULL); /* catch an out of memory condition */
	if (mem == NULL)
	{
		exif_mem_unref(mem);
		return NULL;
	}
	/* Create a new ExifEntry using our allocator */
	ExifEntry *entry = exif_entry_new_mem(mem);
	//ASSERT(entry != NULL);
	if (entry == NULL)
		return NULL;
	/* Allocate memory to use for holding the tag data */
	void *buf = exif_mem_alloc(mem, (ExifLong)len);
	//ASSERT(buf != NULL);
	if (buf == NULL)
	{
		exif_mem_unref(mem);
		exif_entry_unref(entry);
		return NULL;
	}
	/* Fill in the entry */
	entry->data = (unsigned char *)buf;
	entry->size = (unsigned int)len;
	entry->tag = tag;
	entry->components =(unsigned long) len;
	entry->format = EXIF_FORMAT_UNDEFINED;

	/* Attach the ExifEntry to an IFD */
	exif_content_add_entry(m_pExif->ifd[ifd], entry);

	/* The ExifMem and ExifEntry are now owned elsewhere */
	exif_mem_unref(mem);
	exif_entry_unref(entry);

	return entry;
}
bool OExif::InitExifData()
{
	if (m_pExif)
	{
		return true;
	}
	m_pExif = exif_data_new();
	if (!m_pExif)
	{
		return false;
	}
	/* Set the image options */
	exif_data_set_option(m_pExif, EXIF_DATA_OPTION_FOLLOW_SPECIFICATION);
	exif_data_set_data_type(m_pExif, EXIF_DATA_TYPE_COMPRESSED);
	exif_data_set_byte_order(m_pExif, EXIF_BYTE_ORDER_INTEL);

	/* Create the mandatory EXIF fields with default data */
	exif_data_fix(m_pExif);


	return true;
}
bool OExif::GetEntry(char *buf, int tag, int ibufLen)
{
	memset(buf, 0, BUF_SIZE);
	if (m_pExif)
	{
		ExifEntry* entry = exif_data_get_entry(m_pExif, (ExifTag)tag);
		if (entry)
		{
			int ilen = entry->size;
			if (ibufLen!=-1)
			{
				ilen = ibufLen;
			}
			exif_entry_get_value(entry, buf, ov_min(BUF_SIZE - 1, ilen));
			return true;
		}
	}
	return false;
}
bool OExif::GetEntryString(char *buf, int size,int tag)
{
	memset(buf, 0, size);
	if (m_pExif)
	{
		ExifEntry* entry = exif_data_get_entry(m_pExif, (ExifTag)tag);
		if (entry)
		{
			int len = ov_min(size - 1, (int)entry->size+3);
			exif_entry_get_value(entry, buf, len);
			if (size - 1<(int)entry->size)
			{
				OSysDep::Utf8Revise(buf);
			}
			char strAnsi[BUF_SIZE];
			OSysDep::Utf8ToAnsi(buf, strAnsi, BUF_SIZE);
			return true;
		}
	}
	return false;
}
void OExif::DecodePathAndName(const char *strFullPath)
{
	int nlen = (int)strlen(strFullPath);
	strcpy(m_oei.strFullPath, strFullPath);
	int nNamePos = 0;
#ifndef WIN32
#endif
	for (int i = nlen; i >= 0; i--)
	{
		if (strFullPath[i] == '/' || strFullPath[i] == '\\')
		{
			nNamePos = i + 1;
			break;
		}
	}
	if (nlen - nNamePos>99)
	{

		return ;
	}
	if (nNamePos > 255)
	{

		return ;
	}
	strcpy(m_oei.strName, strFullPath + nNamePos);
	memcpy(m_oei.strPath, strFullPath, nNamePos - 1);
}

int OExif::DecodeDateTime(const char *strTime)
{
	if (strTime == NULL || strlen(strTime) < 5)
		return 0;

	const char *ss = strTime;
	int Y = 0, M = 0, D = 0, h = 0, m = 0, s = 0;
	if (ss[4] == ':')
	{
		sscanf(ss, "%d:%d:%d %d:%d:%d", &Y, &M, &D, &h, &m, &s);
		if (M > 12)
		{
			M = M / 100;	//CA0LUJWL.jpg  2008:1118:18 17:16:2
		}
	}
	else if (ss[4] == '-')
	{
		sscanf(ss, "%d-%d-%d %d:%d:%d", &Y, &M, &D, &h, &m, &s);
	}

	if (Y > 0 && Y<10000 && M>0 && M<13 && D>0 && D<32 && h>-1 && h<24 && m>-1 && m<60 && s>-1 && s < 60)
	{
		struct tm tmm;
		memset(&tmm, 0, sizeof(tmm));
		//Ҫʱ
		if (0)
		{
			time_t curtm = time(NULL);
			struct tm* ptmm = NULL;
			ptmm = localtime(&curtm);
			tmm = *ptmm;
		}
		tmm.tm_year = Y - 1900;
		tmm.tm_mon = M - 1;
		tmm.tm_mday = D;
		tmm.tm_hour = h;
		tmm.tm_min = m;
		tmm.tm_sec = s;
		return (int)mktime(&tmm);
	}
	
	return 0;
}

int OExif::DecodeExif()
{
	if (!m_pExif)
	{
		return OEXIF_RET_ERR;
	}
	//m_oei.iLoadOK = 1;
	int iRet = 0;
	exif_data_set_byte_order(m_pExif, EXIF_BYTE_ORDER_INTEL);
	
	char ss[BUF_SIZE];
	if (GetEntry(ss, EXIF_TAG_DATE_TIME_ORIGINAL))
	{
		m_oei.dwDateTime = DecodeDateTime(ss);
		iRet |= OEXIF_RET_OTHER;
	}
	int iLatDir = 0;
	if (GetEntry(ss, EXIF_TAG_GPS_LATITUDE_REF))
	{
		if (ss[0] == 'N')
			iLatDir = 1;
		else if (ss[0] == 'S')
			iLatDir = -1;
		else if (ss[0] == 'R')
		{
			iLatDir = 0;
		}
	}
	if (iLatDir != 0)
	{
		if (GetEntry(ss, EXIF_TAG_GPS_LATITUDE))
		{
			double a = 0, b = 0, c = 0;
			sscanf(ss, "%lf,%lf,%lf", &a, &b, &c);
			m_oei.dLat = (a + b / 60 + c / 3600)*iLatDir;
			iRet |= OEXIF_RET_LAT;
		}
	}
	int iLngDir = 0;
	if (GetEntry(ss, EXIF_TAG_GPS_LONGITUDE_REF))
	{
		if (ss[0] == 'E')
			iLngDir = 1;
		else if (ss[0] == 'W')
			iLngDir = -1;
		else if (ss[0] == 'R')
			iLngDir = 0;
	}
	if (iLngDir != 0)
	{
		if (GetEntry(ss, EXIF_TAG_GPS_LONGITUDE))
		{
			double a = 0, b = 0, c = 0;
			sscanf(ss, "%lf,%lf,%lf", &a, &b, &c);
			m_oei.dLng = (a + b / 60 + c / 3600)*iLngDir;
			iRet |= OEXIF_RET_LNG;
		}
	}
	if (GetEntry(ss, EXIF_TAG_GPS_ALTITUDE))
	{
		int iAlt = 0;
		sscanf(ss, "%d", &iAlt);
		m_oei.iAlt = iAlt;
		iRet |= OEXIF_RET_ALT;
	}
	if (GetEntry(ss, EXIF_TAG_ORIENTATION))
	{
		if (ss[0] == 'T')
		{
			m_oei.bOrientation = OExifOrientation_TOP;
		}
		else if (ss[0] == 'R')
		{
			m_oei.bOrientation = OExifOrientation_RIGHT;
		}
		else if (ss[0] == 'B')
		{
			m_oei.bOrientation = OExifOrientation_BOTTOM;
		}
		else if (ss[0] == 'L')
		{
			m_oei.bOrientation = OExifOrientation_LEFT;
		}
		else
		{
			m_oei.bOrientation = OExifOrientation_NULL;
		}
		iRet |= OEXIF_RET_OTHER;
	}
	if (GetEntry(ss, EXIF_TAG_PIXEL_X_DIMENSION, 10))
	{
		sscanf(ss, "%d", &m_oei.nWidth);
		iRet |= OEXIF_RET_OTHER;
	}
	if (GetEntry(ss, EXIF_TAG_PIXEL_Y_DIMENSION, 10))
	{
		sscanf(ss, "%d", &m_oei.nHeight);
		iRet |= OEXIF_RET_OTHER;
	}
	if (GetEntry(ss, EXIF_TAG_FNUMBER))
	{
		sscanf(ss, "f/%f", &m_oei.fApertureFNumber);
		iRet |= OEXIF_RET_OTHER;
	}
	if (GetEntry(ss, EXIF_TAG_FOCAL_LENGTH))
	{
		sscanf(ss, "%d", &m_oei.nFocalLength);
		iRet |= OEXIF_RET_OTHER;
	}
	if (GetEntry(ss, EXIF_TAG_EXPOSURE_TIME))
	{
		int a = 0, b = 0;
		sscanf(ss, "%d/%d sec", &a, &b);
		if (b == 0)
			b = 1;
		m_oei.fExposureTime = (float)a / b;
		iRet |= OEXIF_RET_OTHER;
	}
	if (GetEntry(ss, EXIF_TAG_X_RESOLUTION))
	{
		sscanf(ss, "%d", &m_oei.nFocalplaneXRes);
		iRet |= OEXIF_RET_OTHER;
	}
	if (GetEntry(ss, EXIF_TAG_Y_RESOLUTION))
	{
		sscanf(ss, "%d", &m_oei.nFocalplaneYRes);
		iRet |= OEXIF_RET_OTHER;
	}
	if (GetEntry(ss, EXIF_TAG_ISO_SPEED_RATINGS))
	{
		sscanf(ss, "%d", &m_oei.nISOequivalent);
		iRet |= OEXIF_RET_OTHER;
	}
	bool bGetString = false;
	bGetString = bGetString|GetEntryString(m_oei.strXpKeyword, sizeof(m_oei.strXpKeyword), EXIF_TAG_XP_KEYWORDS);
	bGetString = bGetString | GetEntryString(m_oei.strMake, sizeof(m_oei.strMake), EXIF_TAG_MAKE);
	bGetString = bGetString | GetEntryString(m_oei.strModel, sizeof(m_oei.strModel), EXIF_TAG_MODEL);
	bGetString = bGetString | GetEntryString(m_oei.strXpAuthor, sizeof(m_oei.strXpAuthor), EXIF_TAG_XP_AUTHOR);
	bGetString = bGetString | GetEntryString(m_oei.strXpTitle, sizeof(m_oei.strXpTitle), EXIF_TAG_XP_TITLE);
	bGetString = bGetString | GetEntryString(m_oei.strXpSubject, sizeof(m_oei.strXpSubject), EXIF_TAG_XP_SUBJECT);
	if (bGetString)
	{
		iRet |= OEXIF_RET_OTHER;
	}
	ExifEntry* entry = exif_data_get_entry(m_pExif, EXIF_TAG_XP_COMMENT);
	if (entry)
	{
		if (entry->size > 0 && entry->size < 100 * 1024)
		{
			int nsize = entry->size + 10;
			m_oei.pStrComent = (char*)zMalloc(nsize);
			m_oei.szOfComent = nsize;
			exif_entry_get_value(entry, m_oei.pStrComent, nsize);
		}
		iRet |= OEXIF_RET_OTHER;
	}
	m_oei.iLoadOK = iRet;
	return iRet;
}

int OExif::LoadExif(void *pBuf, int nBuf)
{
	if (pBuf == NULL || nBuf <= 0)
		return SAVEEXIF_FILE_ERR;
	memsetOExifInfo(&m_oei);
	//memset(&m_oei, 0, sizeof(tagOExifInfo));
	if (m_pExif)
	{
		exif_data_unref(m_pExif);
	}
	m_pExif = exif_data_new_from_data((const unsigned char *)pBuf, (unsigned int)nBuf);
	if (!m_pExif)
		return OEXIF_RET_ERR;
	return DecodeExif();
}
int OExif::LoadExif(const char* strPath)
{
	memsetOExifInfo(&m_oei);
	int nLen = hgetfilelen(strPath);
	if (nLen <= 0)
		return OEXIF_RET_ERR;
	DecodePathAndName(strPath);
	
//#ifdef WIN32
//	OSysDep::Utf8ToAnsi(strPath, m_strFn, sizeof(m_strFn));
//#else
	strcpy(m_strFn,strPath);
//#endif
	if (m_pExif)
	{
		exif_data_unref(m_pExif);
	}
	m_pExif = exif_data_new_from_file(m_strFn);
	if (m_pExif==NULL)
	{
		return OEXIF_RET_ERR;
	}
	

#ifdef  _OPHOTO_PROJ
	if (0)
	{
		char strAnsi[1024] = { 0 };
		char strU2[1024];
		int len = GetExifSignaTxt(strU2, sizeof(strU2));
		if (len > 0)
		{
			OSysDep::Utf8ToAnsi(strU2, strAnsi, sizeof(strAnsi));
			int f = 0;
		}
		char*p = "йձйa";
		memset(strAnsi, 0, 1024);
		for (int i = 0; i < 10; i++)
		{
			strcat(strAnsi, p);
		}
		strcat(strAnsi, "1");
		char strUtf8[1024];
		OSysDep::AnsiToUTF8(strUtf8, strAnsi);

		bool bRet = SetExifSignaTxt(strUtf8);
		if (bRet)
		{
			int len = GetExifSignaTxt(strU2, sizeof(strU2));
			if (len>0)
			{
				OSysDep::Utf8ToAnsi(strU2, strAnsi, sizeof(strAnsi));
				Save();
			}
			
		}
		return 0;
		/*ExifEntry *entry = NULL;
		entry = exif_data_get_entry(m_pExif, (ExifTag)EXIF_TAG_MAKER_NOTE);

		entry = exif_data_get_entry(m_pExif, (ExifTag)EXIF_TAG_DEVICE_SETTING_DESCRIPTION);
		entry = exif_data_get_entry(m_pExif, (ExifTag)EXIF_TAG_OECF);
		entry = exif_data_get_entry(m_pExif, (ExifTag)EXIF_TAG_NEW_CFA_PATTERN);
		entry = exif_data_get_entry(m_pExif, (ExifTag)EXIF_TAG_SPATIAL_FREQUENCY_RESPONSE);
		entry = exif_data_get_entry(m_pExif, (ExifTag)EXIF_TAG_IMAGE_UNIQUE_ID);
		return 0;
		EditPixel(125, 126);*/
		//Save();
		/*char*p = "йձйa";
		char strAnsi[10240] = { 0 };
		for (int i = 0; i < 100;i++)
		{
		strcat(strAnsi, p);
		}
		strcat(strAnsi, "1");
		char strUtf8[10240];
		OSysDep::AnsiToUTF8(strUtf8, strAnsi);
		ExifEntry *entry = NULL;
		int nNum = 0;
		WORD* pw = (WORD*)zMalloc(strlen(strUtf8) * 6 + 2);
		OSysDep::Utf8ToUtf16(strUtf8, pw, &nNum);
		int len = (nNum + 1) * 2+8;
		entry = exif_data_get_entry(m_pExif, (ExifTag)EXIF_TAG_USER_COMMENT);
		if (entry==NULL)
		{
		entry = create_tag(EXIF_IFD_0, EXIF_TAG_USER_COMMENT, len);
		entry->format = EXIF_FORMAT_UNDEFINED;
		entry->size = len;
		entry->components = len;
		}
		else if (len>entry->size)
		{
		void *buf = NULL;
		ExifMem *mem = exif_mem_new_default();
		buf = exif_mem_realloc(mem, buf, len);
		free(mem);
		free(entry->data);
		entry->data = (unsigned char*)buf;
		entry->size = len;
		entry->components = len;
		}
		char stru[10240];
		WORD *ppp = (WORD*)malloc(entry->size-8);
		memcpy(ppp, entry->data+8, entry->size - 8);
		OSysDep::Utf8ToAnsi(OSysDep::Utf16ToUtf8(ppp), strAnsi, sizeof(strAnsi));*/
		/*
		GetEntryString(stru, sizeof(stru), EXIF_TAG_USER_COMMENT);
		OSysDep::Utf8ToAnsi(stru, strAnsi, sizeof(strAnsi));
		char head[] = { 0x55, 0x4E, 0x49, 0x43, 0x4F, 0x44, 0x45, 0x00 };
		memcpy(entry->data, head, sizeof(head));
		memcpy(entry->data + sizeof(head), pw, (1+nNum)*sizeof(WORD));
		GetEntryString(stru, sizeof(stru), EXIF_TAG_USER_COMMENT);
		strAnsi[10240];
		OSysDep::Utf8ToAnsi(stru, strAnsi, sizeof(strAnsi));
		Save();*/
		return 0;
	}

	m_oei.fSize = (float)nLen / 1024 / 1024;
	m_oei.dwCTime = (unsigned int)hgetfileCreatetime(strPath);
	m_oei.dwMTime = (unsigned int)hgetfileModifytime(strPath);
#endif //  _OPHOTO_PROJ


	return DecodeExif();
}
bool OExif::EditGps(double dLat, double dLng, double dAlt,int iTol)
{
	if (!InitExifData())
	{
		return false;
	}
	ExifEntry *entry = exif_content_get_entry(m_pExif->ifd[EXIF_IFD_GPS], (ExifTag)EXIF_TAG_GPS_LATITUDE_REF);
	if (!entry)
	{
		entry = create_tag(EXIF_IFD_GPS, (ExifTag)EXIF_TAG_GPS_LATITUDE_REF, 2);
		if (!entry)
			return false;
	}
	if (dLat >= 0)
	{
		entry->format = EXIF_FORMAT_ASCII;
		entry->components = 2;
		memcpy(entry->data, "N", 2);
	}
	else
	{
		entry->format = EXIF_FORMAT_ASCII;
		entry->components = 2;
		memcpy(entry->data, "S", 2);
		dLat = -dLat;
	}
	entry = exif_content_get_entry(m_pExif->ifd[EXIF_IFD_GPS], (ExifTag)EXIF_TAG_GPS_LATITUDE);
	if (!entry)
	{
		entry = create_tag(EXIF_IFD_GPS, (ExifTag)EXIF_TAG_GPS_LATITUDE, 24);
		if (!entry)
			return false;
		entry->format = EXIF_FORMAT_SRATIONAL;
		entry->components = 3;
	}
	//m_oei.dLat = dLat;
	int du = (int)dLat;
	dLat = (dLat - du) * 60;
	int fen = (int)dLat;
	dLat = (dLat - fen) * 60 ;
	ExifSRational a;
	ExifSRational b;
	ExifSRational c;

	a.numerator = du;
	a.denominator = 1;
	b.numerator = fen;
	b.denominator = 1;
	c.numerator = (int)(dLat*iTol);
	c.denominator = iTol;
	m_oei.dLat = 1.0*a.numerator / a.denominator + 1.0*b.numerator / b.denominator / 60 +
		1.0*c.numerator / c.denominator / 3600;
	entry->format = EXIF_FORMAT_SRATIONAL;
	entry->components = 3;
	exif_set_srational(entry->data, EXIF_BYTE_ORDER_INTEL, a);
	exif_set_srational(entry->data + 8, EXIF_BYTE_ORDER_INTEL, b);
	exif_set_srational(entry->data + 16, EXIF_BYTE_ORDER_INTEL, c);

	entry = exif_content_get_entry(m_pExif->ifd[EXIF_IFD_GPS], (ExifTag)EXIF_TAG_GPS_LONGITUDE_REF);
	if (!entry)
	{
		entry = create_tag(EXIF_IFD_GPS, (ExifTag)EXIF_TAG_GPS_LONGITUDE_REF, 2);
		if (!entry)
			return false;
	}
	if (dLng >= 0)
	{
		entry->format = EXIF_FORMAT_ASCII;
		entry->components = 2;
		memcpy(entry->data, "E", 2);
	}
	else
	{
		entry->format = EXIF_FORMAT_ASCII;
		entry->components = 2;
		memcpy(entry->data, "W", 2);
		dLng = -dLng;
	}
	entry = exif_content_get_entry(m_pExif->ifd[EXIF_IFD_GPS], (ExifTag)EXIF_TAG_GPS_LONGITUDE);
	if (!entry)
	{
		entry = create_tag(EXIF_IFD_GPS, (ExifTag)0x0004, 24);
		if (!entry)
			return false;
		entry->format = EXIF_FORMAT_SRATIONAL;
		entry->components = 3;
	}
	
	du = (int)dLng;
	dLng = (dLng - du) * 60;
	fen = (int)dLng;
	dLng = (dLng - fen) * 60;
	a.numerator = du;
	a.denominator = 1;
	b.numerator = fen;
	b.denominator = 1;
	c.numerator = (int)(dLng*iTol);
	c.denominator = iTol;
	m_oei.dLng = 1.0*a.numerator/a.denominator+1.0*b.numerator/b.denominator/60+
		1.0*c.numerator/c.denominator/3600;
	entry->format = EXIF_FORMAT_SRATIONAL;
	entry->components = 3;
	exif_set_srational(entry->data, EXIF_BYTE_ORDER_INTEL, a);
	exif_set_srational(entry->data + 8, EXIF_BYTE_ORDER_INTEL, b);
	exif_set_srational(entry->data + 16, EXIF_BYTE_ORDER_INTEL, c);

	if (dAlt != 0)
	{

		entry = exif_content_get_entry(m_pExif->ifd[EXIF_IFD_GPS], (ExifTag)EXIF_TAG_GPS_ALTITUDE_REF);
		if (!entry)
		{
			entry = create_tag(EXIF_IFD_GPS, (ExifTag)EXIF_TAG_GPS_ALTITUDE_REF, 1);
			if (!entry)
				return false;
		}

		entry = exif_content_get_entry(m_pExif->ifd[EXIF_IFD_GPS], (ExifTag)EXIF_TAG_GPS_ALTITUDE);

		if (!entry)
		{
			entry = create_tag(EXIF_IFD_GPS, (ExifTag)EXIF_TAG_GPS_ALTITUDE, 8);
			if (!entry)
				return false;
			entry->format = EXIF_FORMAT_SRATIONAL;
			entry->components = 1;
		}

		m_oei.iAlt =(int) dAlt;
		ExifSRational a;
		a.numerator = (int)(dAlt * 100);
		a.denominator = 100;
		exif_set_srational(entry->data, EXIF_BYTE_ORDER_INTEL, a);
	}
	return true;
}
bool OExif::ClearOrientation()
{
	if (!m_pExif)
	{
		return true;
	}
	for (int i = 0; i < EXIF_IFD_COUNT; i++)
	{
		ExifEntry *entry = exif_content_get_entry(m_pExif->ifd[i], EXIF_TAG_ORIENTATION);
		if (entry)
		{
			exif_content_remove_entry(m_pExif->ifd[i], entry);
		}
	} 
	m_oei.bOrientation = OExifOrientation_NULL;
	ExifEntry *entry = NULL;
	entry = exif_data_get_entry(m_pExif, EXIF_TAG_ORIENTATION);
	return entry?false:true;
	
}

bool OExif::SetExifSignaTxt(const char *strValue)
{
	if (!InitExifData())
	{
		return false;
	}

	if (strValue == NULL)
	{
		return false;
	}
	char head[] = { 0x55, 0x4E, 0x49, 0x43, 0x4F, 0x44, 0x45, 0x00 };
	if (1)//utf8
	{
		int len = (int)strlen(strValue) + (int)sizeof(head)+1;
		ExifEntry *entry = NULL;
		entry = exif_data_get_entry(m_pExif, (ExifTag)EXIF_TAG_OMAP_SIGN);
		if (entry == NULL)
		{
			entry = create_tag(EXIF_IFD_EXIF, EXIF_TAG_OMAP_SIGN, len);
			if (entry == NULL)
			{
				return false;
			}
			entry->format = EXIF_FORMAT_UNDEFINED;
			entry->size = len;
			entry->components = len;
		}
		else if (len > (int)entry->size)
		{
			void *buf = NULL;
			ExifMem *mem = exif_mem_new_default();
			buf = exif_mem_realloc(mem, buf, len);
			free(mem);
			free(entry->data);
			entry->data = (unsigned char*)buf;
			entry->size = len;
			entry->components = len;
		}
		
		memcpy(entry->data, head, sizeof(head));
		memcpy(entry->data + sizeof(head), strValue, len-sizeof(head));
	}
	else//utf16
	{
		
		WORD* pw = (WORD*)zMalloc(strlen(strValue) * 6 + 2);
		int nNum = 0;
		OSysDep::Utf8ToUtf16(strValue, pw, &nNum);
		int len = (nNum + 1) * 2 + 8;
		ExifEntry *entry = NULL;
		entry = exif_data_get_entry(m_pExif, (ExifTag)EXIF_TAG_OMAP_SIGN);
		if (entry == NULL)
		{
			entry = create_tag(EXIF_IFD_0, EXIF_TAG_OMAP_SIGN, len);
			if (entry == NULL)
			{
				return false;
			}
			entry->format = EXIF_FORMAT_UNDEFINED;
			entry->size = len;
			entry->components = len;
		}
		else if (len > (int)entry->size)
		{
			void *buf = NULL;
			ExifMem *mem = exif_mem_new_default();
			buf = exif_mem_realloc(mem, buf, len);
			free(mem);
			free(entry->data);
			entry->data = (unsigned char*)buf;
			entry->size = len;
			entry->components = len;
		}
		memcpy(entry->data, head, sizeof(head));
		memcpy(entry->data + sizeof(head), pw, (1 + nNum)*sizeof(WORD));
		free(pw);
	}
	return true;
}
int OExif::GetExifSignaTxt(char *pValue, int iSize)
{
	if (m_pExif == NULL || pValue == NULL || iSize <= 0)
	{
		return -1;
	}
	memset(pValue, 0, iSize);
	ExifEntry *entry = exif_data_get_entry(m_pExif, (ExifTag)EXIF_TAG_OMAP_SIGN);
	if (entry == NULL)
	{
		return -1;
	}
	if (1)
	{
		char head[] = { 0x55, 0x4E, 0x49, 0x43, 0x4F, 0x44, 0x45, 0x00 };
		if (entry->size > sizeof(head) && !memcmp(entry->data, head, sizeof(head)))
		{
			int len = entry->size - sizeof(head);
			if (iSize<len+1)
			{
				len = len - 1;
			}
			memcpy(pValue, entry->data + sizeof(head), len);
			len = OSysDep::Utf8Revise(pValue);
			return len;
		}
		else
		{
			return 0;
		}
	}
	else
	{

		
		
		if (entry->size > 8 && !memcpy(entry->data, "UNICODE", 8))
		{
			//ʾUNICODE 16ֶ
			WORD *pwd = (WORD*)OmMalloc(entry->size - 8);
			memcpy(pwd, entry->data + 8, entry->size - 8);
			char *buf = OSysDep::Utf16ToUtf8(pwd);
			free(pwd);
			int iLen = (int)strlen(buf);
			memcpy(pValue, buf, iSize - 1 < iLen ? iSize - 1 : iLen);
			free(buf);
			if (iLen > iSize - 1)
			{
				OSysDep::Utf8Revise(pValue);
				iLen = iSize - 1;
			}
			return iLen;
		}
		else
		{
			return 0;
		}
	}
}
bool OExif::EditEntryString(char *strBuf, char *strOeiToSave, int iSize, ExifIfd iIFD, ExifTag iTag, bool bToBeUtf16)
{
	if (!InitExifData())
	{
		return false;
	}
	int size2 = (int)strlen(strBuf) + 1;
	if (size2 > iSize)
	{
		strBuf[iSize - 1] = 0;
		OSysDep::Utf8Revise(strBuf);
		size2 =(int) strlen(strBuf) + 1;
		
	}
	WORD *pw = NULL;
	if (bToBeUtf16)
	{
		int len = 0;
		pw = (WORD*)OmMalloc(strlen(strBuf) * 6 + 2);
		OSysDep::Utf8ToUtf16(strBuf, pw, &len);
		size2 = (len+1)*2;
	}
	ExifEntry *entry = NULL;
	if (bToBeUtf16)
	{
		entry = exif_content_get_entry(m_pExif->ifd[iIFD], (ExifTag)iTag);
	}
	else
	{
		entry = exif_data_get_entry(m_pExif, iTag);
	}
	if (!entry)
	{
		entry = create_tag(iIFD, iTag, size2);
		if (!entry)
			return false;
		if (bToBeUtf16)
		{
			entry->format = EXIF_FORMAT_BYTE;
		}
		else
		{
			entry->format = EXIF_FORMAT_ASCII;
		}
		
		entry->components = size2;
	}
	int size1 = entry->size;
	if (size1 < size2)
	{
		void *buf = NULL;
		ExifMem *mem = exif_mem_new_default();
		buf = exif_mem_realloc(mem, buf, size2 + 1);
		free(mem);
		free(entry->data);
		entry->data = (unsigned char*)buf;
		entry->size = size2;
		entry->components = size2;
	}
	strcpy(strOeiToSave, strBuf);
	if (bToBeUtf16)
	{
		memcpy(entry->data, pw, size2);
		free(pw);
	}
	else
	{
		memcpy(entry->data, strBuf, size2);
	}
	return true;
}
bool OExif::EditMake(char* strMake)
{
	return EditEntryString(strMake, m_oei.strMake, sizeof(m_oei.strMake), EXIF_IFD_0, EXIF_TAG_MAKE);
}
bool OExif::EditModel(char* strModel)
{
	return EditEntryString(strModel, m_oei.strModel, sizeof(m_oei.strModel), EXIF_IFD_0, EXIF_TAG_MODEL);
}
bool OExif::EditKeyword(char* strKeyword)
{
	return EditEntryString(strKeyword, m_oei.strXpKeyword, sizeof(m_oei.strXpKeyword), EXIF_IFD_0, EXIF_TAG_XP_KEYWORDS,true);
}
bool OExif::EditSubject(char* strSubject)
{
	return EditEntryString(strSubject, m_oei.strXpSubject, sizeof(m_oei.strXpSubject), EXIF_IFD_0, EXIF_TAG_XP_SUBJECT,true);
}
bool OExif::EditAuthor(char* strAuthor)
{
	return EditEntryString(strAuthor, m_oei.strXpAuthor, sizeof(m_oei.strXpAuthor), EXIF_IFD_0, EXIF_TAG_XP_AUTHOR,true);
}
bool OExif::EditCommnet(char* strComment)
{
	char *pTemp = m_oei.pStrComent;
	int len = (int)strlen(strComment) + 1;
	m_oei.pStrComent = (char*)OmMalloc(len);
	memset(m_oei.pStrComent, 0, len);
	bool br = EditEntryString(strComment, m_oei.pStrComent, len, EXIF_IFD_0, EXIF_TAG_XP_COMMENT,true);
	if (br == false)
	{
		free(m_oei.pStrComent);
		m_oei.pStrComent = pTemp;
	}
	else
	{
		free(pTemp);
	}
	return br;
}
bool OExif::EditTitle(char* strTitle)
{
	return EditEntryString(strTitle, m_oei.strXpTitle, sizeof(m_oei.strXpTitle), EXIF_IFD_0, EXIF_TAG_XP_TITLE, true);
}
//bool OExif::EditCreateTime(unsigned int dwTime)
//{
//	return true;
//}
//bool OExif::EditModifyTime(unsigned int dwTime)
//{
//	return true;
//}
bool OExif::EditCaptureDate(unsigned int dwTime)//ʱ
{
	time_t t;
	t = dwTime;
	char strTime[20];
	hfmtdatetime(t, "yyyy:mm:dd hh:mi:ss", strTime);
	if (EditCaptureDate(strTime))
		return false;

	// m_oei.dwDateTime = dwTime;
	return true;
}

bool OExif::EditCaptureDate(char *strTime)
{
	if (!InitExifData())
	{
		return false;
	}
	ExifEntry *entry = exif_data_get_entry(m_pExif, (ExifTag)EXIF_TAG_DATE_TIME_DIGITIZED);
	if (!entry)
	{
		entry = create_tag(EXIF_IFD_EXIF, (ExifTag)EXIF_TAG_DATE_TIME_DIGITIZED, 20);
		entry->format = EXIF_FORMAT_ASCII;
		entry->components = 20;
	}
	memcpy((char *)entry->data, strTime, 20);
	entry = exif_data_get_entry(m_pExif, (ExifTag)EXIF_TAG_DATE_TIME_ORIGINAL);
	if (!entry)
	{
		entry = create_tag(EXIF_IFD_EXIF, (ExifTag)EXIF_TAG_DATE_TIME_ORIGINAL, 20);
		entry->format = EXIF_FORMAT_ASCII;
		entry->components = 20;
	}
	memcpy((char *)entry->data, strTime, 20);
	entry = exif_data_get_entry(m_pExif, (ExifTag)EXIF_TAG_DATE_TIME);
	if (!entry)
	{
		entry = create_tag(EXIF_IFD_EXIF, (ExifTag)EXIF_TAG_DATE_TIME, 20);
		entry->format = EXIF_FORMAT_ASCII;
		entry->components = 20;
	}
	memcpy((char *)entry->data, strTime, 20);

	m_oei.dwDateTime = DecodeDateTime(strTime);


	return true;
}
bool OExif::EditEntryValue(long lValue, int tag, bool bCreate)
{
	ExifEntry *entry = exif_data_get_entry(m_pExif, (ExifTag)tag);
	if (!entry)
	{
		if (!bCreate)
		{
			return true;
		}
		entry = create_tag(EXIF_IFD_EXIF, (ExifTag)tag, sizeof(long));
		if (entry==NULL)
		{
			return false;
		}
		entry->format = EXIF_FORMAT_LONG;
	}
	memcpy((char *)entry->data, &lValue, sizeof(long));
	return true;
}
bool OExif::EditEntryValue(int iValue, int tag, bool bCreate)
{
	ExifEntry *entry = exif_data_get_entry(m_pExif, (ExifTag)tag);
	if (!entry)
	{
		if (!bCreate)
		{
			return true;
		}
		entry = create_tag(EXIF_IFD_EXIF, (ExifTag)tag, sizeof(int));
		if (entry == NULL)
		{
			return false;
		}
		entry->format = EXIF_FORMAT_LONG;
	}
	memcpy((char *)entry->data, &iValue, sizeof(int));
	return true;
}
bool OExif::EditEntryValue(short sValue, int tag, bool bCreate)
{
	ExifEntry *entry = exif_data_get_entry(m_pExif, (ExifTag)tag);
	if (!entry)
	{
		if (!bCreate)
		{
			return true;
		}
		entry = create_tag(EXIF_IFD_EXIF, (ExifTag)tag, sizeof(short));
		if (entry == NULL)
		{
			return false;
		}
		entry->format = EXIF_FORMAT_SHORT;
	}
	memcpy((char *)entry->data, &sValue, sizeof(short));
	return true;
}
bool OExif::EditPixel(int iWid, int iHei)
{
	if (iWid<=0||iHei<=0)
	{
		return false;
	}
	if (!InitExifData())
	{
		return false;
	}
	bool bRet = true;
	bRet = bRet & EditEntryValue(iWid, EXIF_TAG_PIXEL_X_DIMENSION);
	bRet = bRet & EditEntryValue(iHei, EXIF_TAG_PIXEL_Y_DIMENSION);
	if (bRet)
	{
		m_oei.nWidth = iWid;
		m_oei.nHeight = iHei;
	}
	return bRet;
}
bool OExif::Save(char* strNewPath,char *strTempPath)
{
	/*char strNewFnPath[256];
	memset(strNewFnPath, 0, sizeof(strNewFnPath));
	char strOrgFnPath[256];
	memset(strOrgFnPath, 0, sizeof(strOrgFnPath));
	char strTempFnPath[256];
	memset(strTempFnPath, 0, sizeof(strTempFnPath));*/

	char strNewPathUtf8[256];
	memset(strNewPathUtf8, 0, sizeof(strNewPathUtf8));
	char strOrgPathUtf8[256];
	memset(strOrgPathUtf8, 0, sizeof(strOrgPathUtf8));
	char strTempPathUtf8[256];
	memset(strTempPathUtf8, 0, sizeof(strTempPathUtf8));
	strcpy(strOrgPathUtf8, m_oei.strFullPath);
	if (strNewPath)
	{
		strcpy(strNewPathUtf8, strNewPath);
	}
	else
	{
		strcpy(strNewPathUtf8, m_oei.strFullPath);
	}
	if (strTempPath)
	{
		strcpy(strTempPathUtf8, strTempPath);
	}
	else
	{
		OSysDep::GetAppPath(strTempPathUtf8, 256);
#ifdef WIN32
		strcat(strTempPathUtf8, "\\OExifTmp.jpg");
#else
		strcat(strTempPathUtf8, "/OExifTmp.jpg");
#endif // WIN32
	}
//#ifdef WIN32
//	OSysDep::Utf8ToAnsi(strOrgPathUtf8, strOrgFnPath, 256);
//	OSysDep::Utf8ToAnsi(strNewPathUtf8, strNewFnPath, 256);
//	OSysDep::Utf8ToAnsi(strTempPathUtf8, strTempFnPath, 256);
//#else
//	strcpy(strOrgFnPath, strOrgPathUtf8);
//	strcpy(strNewFnPath, strNewPathUtf8);
//	strcpy(strTempFnPath, strTempPathUtf8);
//#endif // WIN32
	if (!InitExifData())
	{
		return false;
	}
	if (strNewPath)
	{
		long llen = hgetfilelen(strNewPathUtf8);
		if (llen > 0)
		{
			return false;
		}
	}
	ExifData* dde = exif_data_new_from_file(strOrgPathUtf8);
	bool bHasExif = false;
	if (dde != NULL)
	{
		bHasExif = true;
		exif_data_unref(dde);
	}
	char *pBufSrc = NULL;
	DWORD nBufSize = hreadfile(strOrgPathUtf8, &pBufSrc);
	char *pBufDst = NULL;
	int iLen = 0;
	if (nBufSize>0)
	{
		iLen =SaveExifToBuf(pBufSrc, nBufSize, &pBufDst, bHasExif);
		free(pBufSrc);
		pBufSrc = NULL;
	}
	if (iLen>0)
	{
		hwritefile(strNewPathUtf8,pBufDst, iLen);
		free(pBufDst);
		pBufDst = NULL;
		OSysDep::HDeleteFile(strTempPathUtf8);
		return true;
	}
	else
	{
		OSysDep::HDeleteFile(strNewPathUtf8);
		OSysDep::HMoveFile(strTempPathUtf8, strOrgPathUtf8);
		return false;
	}
//	unsigned char exif_header[] = {
//		0xff, 0xd8, 0xff, 0xe1 };
//	/* length of data in exif_header */
//	unsigned int exif_header_len = sizeof(exif_header);
//	unsigned int exif_data_len;
//	unsigned char *exif_data;
//	exif_data_save_data(m_pExif, &exif_data, &exif_data_len);
//	if (exif_data == NULL)
//		return false;
//	FILE *fin = hopenfile(strOrgPathUtf8, "rb");
//	if (fin == NULL)
//	{
//		return false;
//	}
//	fseek(fin, 0, SEEK_END);   //ļĽλÿʼ
//	int bsize = ftell(fin); //ȡļ¶ȡλãͼƬλ
//	rewind(fin);
//	int len = 0;
//	unsigned char *imgdata = (unsigned char*)malloc(bsize);
//	if (!imgdata)
//		return false;
//	fread(imgdata, 1, bsize, fin);
//	fclose(fin);
//	
//	OSysDep::HDeleteFile(strTempPathUtf8);
//	rename(strOrgFnPath, strTempFnPath);
//	FILE *fout = hopenfile(strNewPathUtf8, "ab+");
//	unsigned char eh[] = { 0xff, 0xd8, 0xff, 0xe1, 0xe0 };
//	bool bE0 = false;
//	if (imgdata[3] == eh[4])
//	{
//		bE0 = true;
//	}
//	bool bok = false;
//	bok = fwrite(exif_header, exif_header_len, 1, fout) == 1 && fputc((exif_data_len + 2) >> 8, fout) > -1 && fputc((exif_data_len + 2) & 0xff, fout) > -1
//		&& fwrite(exif_data, exif_data_len, 1, fout) == 1;
//	if (bok==false)
//	{
//		goto SaveError;
//	}
//	if (bHasData)
//	{
//		if (bE0)
//		{
//			len = (int)imgdata[4] * 256 + (int)imgdata[5]+4;
//			if (imgdata[len] == eh[0] && imgdata[1 + len] == eh[3])
//			{
//				len = len + 2 + (int)imgdata[len+2] * 256 + (int)imgdata[len+3];
//				if (fwrite(imgdata + len, bsize - len, 1, fout) != 1)
//				{
//					goto SaveError;
//				}
//			}
//			else
//			{
//				goto SaveError;
//			}
//		}
//		else
//		{
//			if (imgdata[0] == eh[0] && imgdata[1] == eh[1] && imgdata[2] == eh[2] && imgdata[3] == eh[3] )
//			{
//				len = (int)imgdata[4] * 256 + (int)imgdata[5];
//				len = len + 4;
//				if (fwrite(imgdata + len, bsize - len, 1, fout) != 1)
//				{
//					goto SaveError;
//				}
//			}
//			else
//			{
//				goto SaveError;
//			}
//			
//		}
//	}
//	else
//	{
//		unsigned char e[] = {0x00, 0x10};
//		if (imgdata[4] == e[0] && imgdata[5] == e[1])
//		{
//			if (fwrite(imgdata + 20, bsize - 20, 1, fout) != 1)
//				goto SaveError;
//		}
//		else
//		{
//			goto SaveError;
//		}
//	}
//	fclose(fout);
//	free(imgdata);
//	free(exif_data);
//	OSysDep::HDeleteFile(strTempPathUtf8);
//	return true;
//SaveError:
//	fclose(fout);
//	free(imgdata);
//	free(exif_data);
//	OSysDep::HDeleteFile(strNewPathUtf8);
//	rename(strTempPathUtf8, strOrgPathUtf8);
//	return false;
}
//void OExif::test(void *pBufSrc, int nBufSrc)
//{
//	ExifData *ed = exif_data_new_from_data((unsigned char*)pBufSrc, nBufSrc);
//	if (ed)
//	{
//		char pValue[1024];
//		memset(pValue, 0, sizeof(pValue));
//		ExifEntry *entry = exif_data_get_entry(ed, (ExifTag)EXIF_TAG_OMAP_SIGN);
//		if (entry == NULL)
//		{
//			return ;
//		}
//		if (1)
//		{
//			char head[] = { 0x55, 0x4E, 0x49, 0x43, 0x4F, 0x44, 0x45, 0x00 };
//			if (entry->size > sizeof(head) && !memcmp(entry->data, head, sizeof(head)))
//			{
//				int len = entry->size - sizeof(head);
//				if (sizeof(pValue) < len + 1)
//				{
//					len = len - 1;
//				}
//				memcpy(pValue, entry->data + sizeof(head), len);
//				len = OSysDep::Utf8Revise(pValue);
//				char strAnsi[1024];
//				OSysDep::Utf8ToAnsi(pValue, strAnsi, sizeof(strAnsi));
//				int f = 0;
//			}
//		}
//		exif_data_unref(ed);
//	}
//}
int OExif::SaveExifToBuf(void *pBufSrc, int nBufSrc, char**pBufDst, bool bHasExif)
{
	unsigned char exif_header[] = {
		0xff, 0xd8, 0xff, 0xe1 };
	/* length of data in exif_header */
	unsigned int exif_header_len = sizeof(exif_header);
	unsigned int exif_data_len;
	unsigned char *exif_data;
	exif_data_save_data(m_pExif, &exif_data, &exif_data_len);
	
	if (exif_data == NULL)
		return SAVEEXIF_HEADER_ERR;

	int bsize = nBufSrc;
	unsigned char *imgdata = (unsigned char*)pBufSrc;

	int len = exif_header_len + 2 + exif_data_len + bsize;
	char *pBuf = (char *)OmMalloc(len);
	if (pBuf == NULL)
	{
		return SAVEEXIF_MALLOC_ERR;
	}
	memset(pBuf, 0, len);
	unsigned char eh[] = { 0xff, 0xd8, 0xff, 0xe1, 0xe0 };
	bool bE0 = false;
	if (imgdata[3] == eh[4])
	{
		bE0 = true;
	}
	bool bok = false;
	int iPos = 0;
	memcpy(pBuf + iPos, exif_header, exif_header_len);
	iPos += exif_header_len;
	unsigned char exif_Size[2];
	exif_Size[0] = (exif_data_len + 2) >> 8;
	exif_Size[1] = (exif_data_len + 2) & 0xff;
	memcpy(pBuf + iPos, exif_Size, 2);
	iPos += 2;
	memcpy(pBuf + iPos, exif_data, exif_data_len);
	iPos += exif_data_len;
	if (bHasExif)
	{
		if (bE0)
		{
			len = (int)imgdata[4] * 256 + (int)imgdata[5] + 4;
			if (imgdata[len] == eh[0] && imgdata[1 + len] == eh[3])
			{
				len = len + 2 + (int)imgdata[len + 2] * 256 + (int)imgdata[len + 3];
				memcpy(pBuf + iPos, imgdata + len, bsize - len);
				iPos += bsize - len;
			}
			else if (len ==20)
			{
				memcpy(pBuf + iPos, imgdata + len, bsize - len);
				iPos += bsize - len;
			}
			else
			{
				goto SaveError;
			}
		}
		else
		{
			if (imgdata[0] == eh[0] && imgdata[1] == eh[1] && imgdata[2] == eh[2] && imgdata[3] == eh[3])
			{
				len = (int)imgdata[4] * 256 + (int)imgdata[5];
				len = len + 4;
				memcpy(pBuf + iPos, imgdata + len, bsize - len);
				iPos += bsize - len;
			}
			else
			{
				goto SaveError;
			}

		}
	}
	else
	{
		unsigned char e[] = { 0x00, 0x10 };
		if (imgdata[4] == e[0] && imgdata[5] == e[1])
		{
			len = 20;
			memcpy(pBuf + iPos, imgdata + len, bsize - len);
			iPos += bsize - len;
		}
		else
		{
			goto SaveError;
		}
	}
	*pBufDst = pBuf;
	free(exif_data);
	return iPos;
SaveError:
	free(pBuf);
	pBuf = NULL;
	free(exif_data);
	return SAVEEXIF_SAVE_ERR;
}

int OExif::SaveExifToBuf(void *pBufSrc, int nBufSrc, char**pBufDst)
{
	if (nBufSrc<=0)
	{
		return SAVEEXIF_FILE_ERR;
	}
	if (m_pExif == NULL)
		return SAVEEXIF_HEADER_ERR;
	ExifData* dde = exif_data_new_from_data((const unsigned char*)pBufSrc,nBufSrc);
	bool bHasExif = false;
	if (dde != NULL)
	{
		bHasExif = true;
		exif_data_unref(dde);
	}
	return SaveExifToBuf(pBufSrc, nBufSrc, pBufDst, bHasExif);
}
